function [FMin1,XMin1,FCount1,TLm,fTLm,recm,VRLm,frVRLm]=APS(f,n,x,fx,Edg,TL,fTL,rec,VRL,frVRL)
%
%%%%%%%%%%%%%%%%% TS Memory Parameters %%%%%%%%%%%%%%%%
%
dTR=0.01*Edg;                   % TR redius
dSTR=2*dTR;                     % Semi-TR outer redius
nTL=5*n;                        % No. of tabus in TL
inTL=length(fTL);               % Index for No. of tabus in TL
dVR=2*Edg;                      % Region redius in VRL
inVRL=length(frVRL);            % Index for No. of regions in VRL  
etamax=1; etamin=1/nTL;         % Max & Min Recency Ranked Values
nBP=nTL/2.5;                    % No. of Best Points saved in TL
miumax=1; miumin=1/nTL;         % Max & Min f-value Ranked Values
MaxIts=3*n;  
NoImprov=n;
inNoImprov=0;
% Parameters
FCount1=0;                      
fbetter=fx;
fv=zeros(n+2,1);
id=eye(n);
vflag=0;
% **************** Main iteration ******************
% Constructing the Neighborhood Search
itc=0;
while(itc < MaxIts & inNoImprov < NoImprov);   
    % Check Hitting the STR
    itc=itc+1;  
    S=zeros(n+2,n);
    fbetter=fx;
    STRHitTest=0;
    indd=0;
    for j=1:inTL;        
        if norm(x-TL(j,:))<dSTR            
            indd=indd+1;            
        end
    end 
    if indd>0; STRHit=zeros(indd,n); end
    indd=0;
    for j=1:inTL;        
        if norm(x-TL(j,:))<dSTR            
            indd=indd+1;
            dxSTR(indd)=norm(x-TL(j,:));
            STRHit(indd,:)=TL(j,:);
            STRHitTest=1;
        end
    end    
    if STRHitTest == 1
        % Constructing the Neighborhood Search under Hitting STR
        ddmax=max(dxSTR);        
        if indd == 1
            Tbar=STRHit;
        else 
            Tbar=sum(STRHit)/indd;
        end
        in=1;        
        sgn=sign(x-Tbar);
		while(fbetter >= fx & in <= n)                         
            if sgn(in)==0; sgn(in)=(-1)^round(rand); end
            S(in,:)=x+ddmax*sgn(in)*id(in,:);
            for k=1:inTL
                if norm(S(in,:)-TL(k,:))<dTR
                    vd=TL(k,:)-x;
                    newedg=abs(vd(in))+sqrt(dTR^2+(norm(vd))^2-(vd(in))^2);
                    S(in,:)=x+newedg*(1+0.1*rand)*sgn(in)*id(in,:);
                end
            end          
            fv(in)=feval(f,S(in,:));
            FCount1=FCount1+1;
            if fv(in)<fbetter
                x1=S(in,:);
                f1=fv(in);
                Bflag=1;        
                fbetter=fv(in); 
            else
                Bflag=0;
            end
            in=in+1;
		end
    else
        % Constructing the normal Neighborhood Search
        in=1;  
        if vflag==1
            sn=sign(v);
        else
            rn=rand(n,1);sn=(-1).^round(rn);
        end        
		while(fbetter >= fx & in <= n)              
            EdgL=Edg+rand*Edg;  
            if sn(in)==0; sn(in)=(-1)^round(rand); end
            S(in,:)=x+sn(in)*EdgL*id(in,:); 
            Sflag=3;
            for k=1:inTL
                if norm(S(in,:)-TL(k,:))<dTR
                    vd=TL(k,:)-x;
                    newedg=abs(vd(in))+sqrt(dTR^2+(norm(vd))^2-(vd(in))^2);
                    S(in,:)=x+newedg*(1+0.1*rand)*sn(in)*id(in,:);  
                end
            end                   
            for j=1:inTL;
                dx1=norm(S(in,:)-TL(j,:));
                if(dx1 < dSTR)
                    EdgL= dx1+(1+0.5*rand)*dSTR;                    
                    S(in,:)=x+EdgL*id(in,:);
                end
            end
            fv(in)=feval(f,S(in,:));
            FCount1=FCount1+1;
            if fv(in)<fbetter
                x1=S(in,:);
                f1=fv(in);
                Bflag=1;        
                fbetter=fv(in);
            else
                Bflag=0; 
            end
            in=in+1;
		end
    end       
    if (Bflag == 0)
        df=zeros(n,1);
        u=zeros(n,n);
        v=zeros(1,n);    
        for j=1:n;        
            df(j)=fv(j)-fx;
		end	              
		for i=1:n; 
            w(i)=df(i)/sum(abs(df));
            u(i,:)=-(S(i,:)-x); 
            u(i,:)=u(i,:)/norm(u(i,:));
		end         
        for j=1:n; v=v+w(j)*u(j,:); end    
        v=v/norm(v);
        S(n+1,:)=x+(0.5*rand)*Edg*v;
        S(n+2,:)=x+(0.5+rand)*Edg*v;    
        for j=1:2
            jn=n+j;
            fv(jn)=feval(f,S(jn,:));
        end        
        [fvs,is]=sort(fv); 
        Stmp=S(is,:); S=Stmp; fv=fvs;    
        xnew=S(1,:);
        fnew=fv(1);
        vflag=1;
	else
        xnew=x1; fnew=f1;
        vflag=0;
	end
	% TL and VRL Update    
	if(inTL < nTL) 
        inTL=inTL+1; TL(inTL,:)=x; 
        fTL(inTL)=fx; rec(inTL)=itc+1;
    else
        [sort1,is1]=sort(rec);        
        [sort2,is2]=sort(fTL);         
        for j=1:nTL; 
            MR(is1(j))=etamin+(etamax-etamin)*(j-1)/(nTL-1);
        end
        MFv=miumin*ones(1,nTL);
        for j=1:nBP;
            MFv(is2(j))=miumin+(miumax-miumin)*(nBP-j)/(nBP-1);            
        end
        for j=1:nTL; 
            Memb(j)=max(MR(j),MFv(j));
        end
        [sortMemb,iMembs]=sort(Memb); 
        TLtmp=TL(iMembs,:); TL=TLtmp;
        rectmp=rec(iMembs); rec=rectmp;
        fTLtmp=fTL(iMembs); fTL=fTLtmp;
        TL(1,:)=x; fTL(1)=fx; rec(1)=itc+1;
    end
    dxVR=zeros(1,inVRL);
    for j=1:inVRL
        dxVR(j)=norm(x-VRL(j,:));
        if dxVR(j) < dVR
            frVRL(j)=frVRL(j)+1;
        end
    end
	if(min(dxVR) > dVR)
        inVRL=inVRL+1; VRL(inVRL,:)=x; frVRL(inVRL)=1;        
    end   
    if fnew<fx
        inNoImprov=0;
    else
        inNoImprov=inNoImprov+1;
    end    
    x=xnew; fx=fnew;  
end
[fTLs,ifTL]=sort(fTL); 
TLtmp=TL(ifTL,:);
TL=TLtmp; fTL=fTLs;
rectmp=rec(ifTL); rec=rectmp;
FMin1=fTL(1); XMin1=TL(1,:); XM1=TL;
TLm=TL; fTLm= fTL; recm=rec; VRLm=VRL; frVRLm=frVRL;